import { OnApplicationShutdown } from '@nestjs/common';
import { Driver, Result } from 'neo4j-driver';
import { Neo4jConfig } from './interfaces/neo4j-config.interface';
export declare class Neo4jService implements OnApplicationShutdown {
    private readonly driver;
    private readonly config;
    constructor(config: Neo4jConfig, driver: Driver);
    onApplicationShutdown(): Promise<void>;
    getConfig(): Neo4jConfig;
    getReadSession(database?: string): import("neo4j-driver/types/session").default;
    getWriteSession(database?: string): import("neo4j-driver/types/session").default;
    read(query: string, params?: object, database?: string): Result;
    write(query: string, params?: object, database?: string): Result;
}
