"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Neo4jService = void 0;
const common_1 = require("@nestjs/common");
const neo4j_driver_1 = require("neo4j-driver");
const neo4j_constants_1 = require("./neo4j.constants");
let Neo4jService = class Neo4jService {
    constructor(config, driver) {
        this.driver = driver;
        this.config = config;
    }
    onApplicationShutdown() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.driver.close();
        });
    }
    getConfig() {
        return this.config;
    }
    getReadSession(database) {
        return this.driver.session({
            database: database || this.config.database,
            defaultAccessMode: neo4j_driver_1.session.READ,
        });
    }
    getWriteSession(database) {
        return this.driver.session({
            database: database || this.config.database,
            defaultAccessMode: neo4j_driver_1.session.WRITE,
        });
    }
    read(query, params, database) {
        const session = this.getReadSession(database);
        return session.run(query, params);
    }
    write(query, params, database) {
        const session = this.getWriteSession(database);
        return session.run(query, params);
    }
};
Neo4jService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject(neo4j_constants_1.NEO4J_OPTIONS)),
    __param(1, common_1.Inject(neo4j_constants_1.NEO4J_DRIVER)),
    __metadata("design:paramtypes", [Object, Object])
], Neo4jService);
exports.Neo4jService = Neo4jService;
